#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_DailyQuestRewardCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_DailyQuestRewardCFG> M_DailyQuestRewardCFG::msSingleton(nullptr);

int M_DailyQuestRewardCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_DailyQuestRewardCFGData* M_DailyQuestRewardCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_DailyQuestRewardCFGData>& M_DailyQuestRewardCFG::GetMapData()
{
	return mMapData;
}

void M_DailyQuestRewardCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_DailyQuestRewardCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_DailyQuestRewardCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mNeedScore = element->IntAttribute("NeedScore");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_DailyQuestRewardCFG::Load()
{
	Load("../Config/M_DailyQuestRewardCFG.xml");
}

M_DailyQuestRewardCFG* M_DailyQuestRewardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_DailyQuestRewardCFG());
	}
	return msSingleton.get();
}
